// ShapesExampleView.cpp : implementation of the CShapesExampleView class
//

#include "stdafx.h"
#include "ShapesExample.h"

#include "ShapesExampleDoc.h"
#include "ShapesExampleView.h"
#include "SelectShapeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CShapesExampleView

IMPLEMENT_DYNCREATE(CShapesExampleView, CView)

BEGIN_MESSAGE_MAP(CShapesExampleView, CView)
	//{{AFX_MSG_MAP(CShapesExampleView)
	ON_COMMAND(ID_TASKS_SELECTTHESHAPE, OnTasksSelecttheshape)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CShapesExampleView construction/destruction

CShapesExampleView::CShapesExampleView()
{
	// TODO: add construction code here

}

CShapesExampleView::~CShapesExampleView()
{
}

BOOL CShapesExampleView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CShapesExampleView drawing

void CShapesExampleView::OnDraw(CDC* pDC)
{
	CShapesExampleDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	DrawShapes(pDC);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CShapesExampleView printing

BOOL CShapesExampleView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CShapesExampleView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CShapesExampleView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CShapesExampleView diagnostics

#ifdef _DEBUG
void CShapesExampleView::AssertValid() const
{
	CView::AssertValid();
}

void CShapesExampleView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CShapesExampleDoc* CShapesExampleView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CShapesExampleDoc)));
	return (CShapesExampleDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CShapesExampleView message handlers

void CShapesExampleView::OnTasksSelecttheshape() 
{
	// TODO: Add your command handler code here
	CSelectShapeDlg SelectShapeDlg;
	if(SelectShapeDlg.DoModal()==IDOK)
	{
		m_strSelectedShape=SelectShapeDlg.m_strSelectedShape;
		m_strCaption=SelectShapeDlg.m_strCaption;

		Invalidate();

	}
}

void CShapesExampleView::DrawShapes(CDC* pDC)
{
	if(m_strSelectedShape==_T("Circle"))
	{
		pDC->Ellipse(100,100,300,300);
	}
	else if(m_strSelectedShape==_T("Rectangle"))
	{
		CBrush brush;
		brush.CreateSolidBrush(RGB(230,255,0));

		// Select the brush into a device context, and draw.
		CBrush* pOldBrush = (CBrush*)pDC->SelectObject(&brush);
		pDC->RoundRect(CRect(50, 50, 200, 200), CPoint(10,10));

		// Restore the original brush.
		pDC->SelectObject(pOldBrush);
	}
	else if(m_strSelectedShape==_T("Round Rectangle"))
	{
		WORD HatchBits[8] = { 0x11, 0x22, 0x44, 0x88, 0x11,
			0x22, 0x44, 0x88 };

		// Use the bit pattern to create a bitmap.
		CBitmap bm;
		bm.CreateBitmap(8,8,1,1, HatchBits);


		CBrush brush;
		brush.CreatePatternBrush(&bm);

		// Select the brush into a device context, and draw.
		CBrush* pOldBrush = (CBrush*)pDC->SelectObject(&brush);
		pDC->RoundRect(CRect(50, 50, 200, 200), CPoint(10,10));

		// Restore the original brush.
		pDC->SelectObject(pOldBrush);

	}
	else if(m_strSelectedShape==_T("Line"))
	{
		pDC->MoveTo(100,100);
		pDC->LineTo(300,250);
	}
	else
	{
		pDC->TextOut(100,100,"Primitive Shapes Example..");
	}

	pDC->TextOut(100,300,m_strCaption);
}
